## drbd 0.6.12

=== Makefile ===
# Makefile for drbd
#
# This file is part of drbd by Philipp Reisner
#
# drbd is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# drbd is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with drbd; see the file COPYING.  If not, write to
# the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
#

include Makefile.vars
REL_VERSION = $(word 3, $(shell grep REL_VERSION drbd_config.h))

all: INSTALL.html
	@ for i in $(SUBDIRS); do $(MAKE) -C $$i all || test $$i = documentation || exit 1 ; done
	@ echo -e "\n\tBuild successful."

install:
	@ for i in $(SUBDIRS); do $(MAKE) -C $$i install || test $$i = documentation || exit 1 ; done

clean:
	@ set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i clean; done
	rm -f *~ .filelist INSTALL.html INSTALL.pod pod2htm*
	rm -rf dist

uninstall:
	@ set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i uninstall; done

check_changelogs_up2date:
	@ up2date=true; rver_re=$(REL_VERSION); rver_re=$${rver_re//./\\.}; \
	in_changelog=$$(sed -n -e '0,/^%changelog/d' \
	                     -e '/^- *drbd ('"$$rver_re"'-/p' \
	                     -e '/^\*.* \['"$$rver_re"'-/p' < drbd.spec.in) ; \
	if test -z "$$in_changelog" ; \
	then \
	   echo "You need to update the %changelog in drbd.spec.in"; \
	   up2date=false; fi; \
	if ! grep "^drbd ($$rver_re-" >/dev/null 2>&1 debian/changelog; \
	then \
	   echo "You need to update debian/changelog"; \
	   up2date=false; fi ; \
	if ! grep "^drbd_$$rver_re-" >/dev/null 2>&1 debian/files; \
	then \
	   echo "You need to update debian/files"; \
	   up2date=false; fi ; \
	$$up2date

update.filelist:
	cvs status | grep -o "/drbd/drbd/[^,]*" | \
	sed "s/\/drbd\/drbd/drbd-$(REL_VERSION)/" > .filelist
	find documentation -name "*.[58]" -o -name "*.html" | \
	sed "s/^/drbd-$(REL_VERSION)\//" >> .filelist
	echo drbd-$(REL_VERSION)/.filelist >> .filelist

.filelist:
	@ echo -e "\nto create the filelist:   make update.filelist\nyou need cvs access, though.\n"
	@ false

tgz: .filelist
ifeq ($(FORCE),)
	$(MAKE) -C documentation
endif
	cd scripts; ln -sf drbd datadisk
	rm -f drbd-$(REL_VERSION)
	ln -s . drbd-$(REL_VERSION)
	tar --owner=0 --group=0 -czf drbd-$(REL_VERSION).tar.gz -T .filelist
	rm drbd-$(REL_VERSION)

ifeq ($(FORCE),)
tgz: check_changelogs_up2date
endif

KDIR := $(shell echo /lib/modules/`uname -r`/build)
KVER := $(shell \
	echo -e "\#include <linux/version.h>\ndrbd_kernel_release UTS_RELEASE" | \
        gcc -nostdinc -E -P -I$(KDIR)/include - 2>&1 | \
        sed -ne 's/^drbd_kernel_release "\(.*\)".*/\1/p')

# maybe dist/RPMS/$(ARCH) instead of i386 ?
rpm: tgz
	mkdir -p dist/BUILD \
	         dist/RPMS/i386 \
	         dist/SPECS \
	         dist/SOURCES \
	         dist/TMP \
	         dist/install \
	         dist/SRPMS
	[ -h dist/SOURCES/drbd-$(REL_VERSION).tar.gz ] || \
	  $(LN_S) $(PWD)/drbd-$(REL_VERSION).tar.gz \
	          $(PWD)/dist/SOURCES/drbd-$(REL_VERSION).tar.gz
	if test drbd.spec.in -nt dist/SPECS/drbd.spec ; then \
	   sed -e "s/^\(Version:\).*/\1 $(REL_VERSION)/;" \
	       -e "s/^\(Packager:\).*/\1 $(USER)@$(HOSTNAME)/;" < drbd.spec.in \
	   > dist/SPECS/drbd.spec ; \
	fi
	$(RPMBUILD) -ba ${RPMOPTIONS}\
	    --define "_topdir $(PWD)/dist" \
	    --define "buildroot $(PWD)/dist/install" \
	    --define "kernelversion $(KVER)" \
	    --define "kdir $(KDIR)" \
	    $(PWD)/dist/SPECS/drbd.spec

# the INSTALL file is writen in lge-markup, which is basically
# wiki style plus some "conventions" :)
# why don't I write in or convert to HTML directly?
# editing INSTALL feels more natural this way ...

INSTALL.html: INSTALL.pod
	-pod2html --title "Howto Build and Install DRBD" \
		< INSTALL.pod > INSTALL.html ; rm -f pod2htm*
#	-w3m -T text/html -dump < INSTALL.html > INSTALL.txt

INSTALL.pod: INSTALL
	-@perl -pe 'BEGIN { print "=pod\n\n"; };                   \
	 	s/^= +(.*?) +=$$/=head1 $$1/;                     \
	 	s/^== +(.*?) +==$$/=head2 $$1/;                   \
	 	if(s/^ +([^#]*)$$/$$1/ or /^\S/) {                \
			s/(Note:)/B<$$1>/g;                       \
			s/"([^"]+)"/C<$$1>/g;                     \
	 		s,((^|[. ])/(\S|`[^`]*`)+),C<$$1>,g;\
	 	}' \
	 	< INSTALL > INSTALL.pod

=== benchmark/Makefile ===
all: dm

dm: dm.c
	gcc -o dm dm.c
	strip dm

install:

uninstall:
	rm -f dm

clean: 
	rm -f dm

=== documentation/Makefile ===
# Makefile in documentation directory
#
# This file is part of drbd by Philipp Reisner
#
# drbd is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# drbd is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with drbd; see the file COPYING.  If not, write to
# the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
#
#
# For Debian:
# nsgmls drbdsetup.sgml | sgmlspl /usr/lib/perl5/sgmlspl-specs/docbook2man-spec.pl
# On RedHat it is at:
# /usr/share/sgml/docbook/utils-0.6/helpers/docbook2man-spec.pl
# the RedHat only way is docbook2man
# hmmm, nowadays docbook2man works also on Debian

include ../Makefile.vars
LANGS=ja pt_BR

####### Implicit rules

.SUFFIXES: .sgml .5 .8 .html .pdf .ps

.sgml.5:
	$(DB2MAN) $<

.sgml.8:
	$(DB2MAN) $<

.sgml.html:
	$(DB2HTML) $<
	mv index.html $@

.sgml.pdf:
	$(DB2PDF) $< 
	if [ $@ = drbd.conf.pdf ]; then mv drbd.pdf drbd.conf.pdf; fi 

.sgml.ps:
	$(DB2PS) $< 
	if [ $@ = drbd.conf.ps ]; then mv drbd.ps drbd.conf.ps; fi 
	gzip -c $@ > $@.gz

#######

ifneq ($(DB2MAN)$(DB2HTML)$(DB2PDF)$(DB2PS),)
all:	prepare man HOWTO/index.html

clean:
	rm -f *.[58] manpage.links manpage.refs *~ manpage.log
	rm -f  HOWTO/{*.html,*.css,suse-*.dsl,CATALOG.local}
	rm -rf HOWTO/{DRBD-HOWTO*,db2html*}/
	rm -f *.ps.gz *.pdf *.ps *.html pod2htm*
	@ set -e; for i in $(LANGS); do ln -sf ../Makefile.lang $$i/Makefile ; $(MAKE) -C $$i clean ; rm $$i/Makefile ; done

else

all:    prepare
	@echo "could not find docbook tools, sorry."

clean:
	@echo "could not find docbook tools, leaving documentation in place."

endif

drbd-article.html: drbd-article.pod
	rm -f drbd-article.html
	-pod2html --title "Data Redundance By DRBD" < drbd-article.pod |\
		sed '/rev="made"/d' > drbd-article.html
	rm -f pod2htm*

all: drbd-article.html

prepare:
	@ set -e; for i in $(LANGS); do ln -sf ../Makefile.lang $$i/Makefile; done

man:	drbdsetup.8 drbd.conf.5 drbd.8 datadisk.8 
	@ set -e; for i in $(LANGS); do $(MAKE) -C $$i man; done	

HOWTO/index.html: HOWTO/DRBD-HOWTO.sgml
	@cd HOWTO ; $(DB2HTML) DRBD-HOWTO.sgml ; cd ..

install: drbdsetup.8 drbd.conf.5 drbd.8 datadisk.8
	install -D -m 644 drbd.conf.5 $(PREFIX)usr/share/man/man5/drbd.conf.5 
	install -D -m 644 drbd.8      $(PREFIX)usr/share/man/man8/drbd.8 
	install -D -m 644 datadisk.8  $(PREFIX)usr/share/man/man8/datadisk.8 
	install -D -m 644 drbdsetup.8 $(PREFIX)usr/share/man/man8/drbdsetup.8
	@ set -e; for i in $(LANGS); do $(MAKE) -C $$i install; done

uninstall:
	rm $(PREFIX)usr/share/man/man8/drbdsetup.8
	rm $(PREFIX)usr/share/man/man5/drbd.conf.5
	rm $(PREFIX)usr/share/man/man8/drbd.8
	rm $(PREFIX)usr/share/man/man8/datadisk.8
	@ set -e; for i in $(LANGS); do $(MAKE) -C $$i uninstall; done

html:	prepare $(shell ls *.sgml | sed s/sgml/html/g)	
	@ set -e; for i in $(LANGS); do $(MAKE) -C $$i html; done	
pdf:	prepare $(shell ls *.sgml | sed s/sgml/pdf/g)
	@ set -e; for i in $(LANGS); do $(MAKE) -C $$i pdf; done	
ps:	prepare $(shell ls *.sgml | sed s/sgml/ps/g)
	@ set -e; for i in $(LANGS); do $(MAKE) -C $$i ps; done

=== scripts/Makefile ===
# Makefile for scripts
#
# This file is part of drbd by Philipp Reisner
#
# drbd is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# drbd is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with drbd; see the file COPYING.  If not, write to
# the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
#
# for Debian:
#   update-rc.d drbd defaults 70 08
#

include ../Makefile.vars

ifeq ($(DIST),slackware)
  INITD=etc/rc.d/
endif

ifeq ($(DIST),debian)
  INITD=etc/init.d/
endif

ifeq ($(DIST),redhat)
  INITD=etc/rc.d/init.d/
endif

ifeq ($(DIST),suse)
   INITD=etc/init.d/
endif

ifeq ($(DIST),rock)
  INITD=etc/rc.d/init.d/
endif

ifeq ($(INITD),,)
   $(warning Can not guess distribution INITD, please fix Makefile.vars)
   $(warning Assume INITD=etc/init.d according to LSB)
   INITD=etc/init.d
endif

all:
	ln -sf drbd datadisk

install:
	mkdir -p $(PREFIX)etc/ha.d/resource.d
	install -D -m 755 drbd $(PREFIX)$(INITD)/drbd
	@ if [ ! -e $(PREFIX)etc/drbd.conf ]; then \
		install -D -m 644 drbd.conf $(PREFIX)etc/drbd.conf; \
	fi
	ln -sf ../../../$(INITD)drbd $(PREFIX)etc/ha.d/resource.d/datadisk
ifeq ($(DIST),suse)
	ln -sf ../$(INITD)drbd $(PREFIX)sbin/rcdrbd
endif
	@ echo
	@ echo "Don't forget to run update-rc.d or chkconfig"

clean:
	rm -f *~
	rm -f datadisk

uninstall:
	rm $(PREFIX)$(INITD)drbd
	rm $(PREFIX)etc/ha.d/resource.d/datadisk
	test "$(DIST)" = suse && rm $(PREFIX)sbin/rcdrbd

=== testing/Makefile ===
all: show_size # acmp receiver sender writetest

show_size: show_size.c
	gcc -o show_size show_size.c

#writetest: writetest.c
#	gcc -g -o writetest writetest.c

#receiver: receiver.c
#	gcc -g -o receiver receiver.c

#sender: sender.c
#	gcc -g -o sender sender.c

clean: 
	rm -f show_size

=== user/Makefile ===
# Makefile for drbd.o
#
# This file is part of drbd by Philipp Reisner
#
# drbd is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# drbd is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with drbd; see the file COPYING.  If not, write to
# the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
#

include ../Makefile.vars

####### Implicit rules

.SUFFIXES: .c .o

.c.o:
	$(CC) -c $(USERFLAGS) $(VERSIONFLAGS) $<

#######


all: drbdsetup

drbdsetup: drbdsetup.o
	$(CC) -o drbdsetup drbdsetup.o

clean:
	rm -f drbdsetup *.o 
	rm -f *~

install:
	install -D -m 755 drbdsetup $(PREFIX)sbin/drbdsetup

uninstall:
	rm $(PREFIX)sbin/drbdsetup

=== documentation/HOWTO/Makefile ===
# Generates online and print versions of SGML source file.

BASENAME=DRBD-HOWTO

# SGML source file.
SGML_FILE=$(BASENAME).sgml

# Stylesheets
DSL_PRINT=$(SGML_SHARE)/dsssl-stylesheets/print/ldp.dsl\#print
DSL_HTML=$(SGML_SHARE)/dsssl-stylesheets/html/ldp.dsl\#html

# Generated files.
HTML_FILE=index.html
HTM_FILE=$(BASENAME).htm
TEX_FILE=$(BASENAME).tex
RTF_FILE=$(BASENAME).rtf
PDF_FILE=$(BASENAME).pdf
DVI_FILE=$(BASENAME).dvi
PS_FILE=$(BASENAME).ps


# Build rules.

html: $(HTML_FILE)

htm: $(HTM_FILE)

tex: $(TEX_FILE)

rtf: $(RTF_FILE)

pdf: $(PDF_FILE)

dvi: $(DVI_FILE)

ps: $(PS_FILE)

all: html htm tex rtf pdf dvi ps

clean:
	rm -f $(BASENAME).{htm,log,aux,ps,pdf,tex,dvi,rtf,fot}
	rm -f *.html

distclean: clean
	rm -f $(BASENAME).tgz

package:
	rm -f $(BASENAME).tgz
	tar -C .. -czf /tmp/$(BASENAME).tgz $(BASENAME)
	mv /tmp/$(BASENAME).tgz .

dist: clean package

distall: all package


# Compile rules.

$(HTML_FILE): $(SGML_FILE)
	openjade -t sgml -d $(DSL_HTML) $(SGML_FILE)

$(HTM_FILE): $(SGML_FILE)
	openjade -t sgml -V nochunks -d $(DSL_HTML) \
	$(SGML_FILE) > $(HTM_FILE)

$(TEX_FILE): $(SGML_FILE)
	openjade -t tex -d $(DSL_PRINT) $(SGML_FILE)

$(RTF_FILE): $(SGML_FILE)
	openjade -t rtf -d $(DSL_PRINT) $(SGML_FILE)

# [pdf]jadetex is run 3 times to resolve references.
#$(PDF_FILE): $(TEX_FILE)
#       pdfjadetex $(TEX_FILE)
#       pdfjadetex $(TEX_FILE)
#       pdfjadetex $(TEX_FILE)

# This *should* work, but htmldoc has bugs ...
#$(PDF_FILE): $(SGML_FILE)
#       openjade -t sgml -V nochunks -d $(DSL_HTML) \
#       $(SGML_FILE) | htmldoc -f $(PDF_FILE) -

# Have to use ldp_print to work around htmldoc bugs
# ldp_print can also do the ps file - see script
$(PDF_FILE): $(HTM_FILE)
	ldp_print $(HTM_FILE)

$(DVI_FILE): $(TEX_FILE)
	jadetex $(TEX_FILE)
	jadetex $(TEX_FILE)
	jadetex $(TEX_FILE)

$(PS_FILE): $(DVI_FILE)
	dvips $(DVI_FILE) -o $(PS_FILE)

#$(PS_FILE): $(SGML_FILE)
#       openjade -t sgml -V nochunks -d $(DSL_HTML) \
#       $(SGML_FILE) | htmldoc -f $(PS_FILE) -

## drbd 0.7.7-1

=== Makefile ===
# Makefile for drbd
#
# This file is part of drbd by Philipp Reisner
#
# drbd is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# drbd is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with drbd; see the file COPYING.  If not, write to
# the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
#

# TODO move some of the more cryptic bash scriptlets here into scripts/*
# and call those from here.	-- lge 

#PREFIX      = /usr/local

SUBDIRS     = user scripts documentation drbd #testing #benchmark
ALLSUBDIRS  = user scripts benchmark documentation drbd testing

REL_VERSION := $(shell sed -ne '/REL_VERSION/{s/^[^"]*"\([^ "]*\).*/\1/;p;q;}' drbd/linux/drbd_config.h)
ifdef FORCE
#
# NOTE to generate a tgz even if too lazy to update the changelogs,
# or to forcefully include the svn-last-changed-date in the tgz name:
#   make distclean doc tgz FORCE=1
#
REL_VERSION := $(REL_VERSION)-$(shell svn info| \
		  sed -ne 's/^Last Changed Date: \([0-9]*\)-\([0-9]*\)-\([0-9]*\).*/\1\2\3/p')
endif

DIST_VERSION := $(subst -,_,$(REL_VERSION))

LN_S = ln -s
RPMBUILD=rpmbuild

all:
	@ set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i ; done
	@ echo -e "\n\tBuild successful."

tools:
	@ set -e; for i in $(patsubst drbd,,$(SUBDIRS)); do $(MAKE) -C $$i ; done
	@ echo -e "\n\tBuild successful."

doc:
	$(MAKE) -C documentation doc

doc-clean:
	$(MAKE) -C documentation doc-clean

install:
	@ set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i install; done

install-tools:
	@ set -e; for i in $(patsubst drbd,,$(SUBDIRS)); do $(MAKE) -C $$i install; done

clean:
	@ set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i clean; done
	rm -f *~
	rm -rf dist

distclean:
	@ set -e; for i in $(ALLSUBDIRS); do $(MAKE) -C $$i distclean; done
	rm -f *~ .filelist
	rm -rf dist

uninstall:
	@ set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i uninstall; done

check_changelogs_up2date:
	@ up2date=true; dver_re=$(DIST_VERSION); dver_re=$${dver_re//./\\.}; \
	echo "checking for presence of $$dver_re in various changelog files"; \
	in_changelog=$$(sed -n -e '0,/^%changelog/d' \
	                     -e '/^- *drbd ('"$$dver_re"'-/p' \
	                     -e '/^\*.* \['"$$dver_re"'-/p' < drbd.spec.in) ; \
	if test -z "$$in_changelog" ; \
	then \
	   echo "You need to update the %changelog in drbd.spec.in"; \
	   up2date=false; fi; \
	if ! grep "^$$dver_re\>" >/dev/null 2>&1 ChangeLog; \
	then \
	   echo "You need to update ChangeLog"; \
	   up2date=false; fi ; \
	if ! grep "^drbd ($$dver_re-" >/dev/null 2>&1 debian/changelog; \
	then \
	   echo -e "\n\n\tdebian/changelog needs some update\n"; \
	   : do not fail the build because of outdated debian/changelog ; fi ; \
	$$up2date

# XXX this is newly created whenever the toplevel makefile does something.
# however it is NOT updated when you just do a make in user/ or drbd/ ...
#
# update of drbd_buildtag.c is forced:
.PHONY: drbd/drbd_buildtag.c
drbd/drbd_buildtag.c:
	@is_tarball=`test -e .svn/. && echo false || echo true`;		\
	set -e; exec > $@.new;							\
	echo -e "/* automatically generated. DO NOT EDIT. */";			\
	echo -e "const char * drbd_buildtag(void)\n{";			\
	if $$is_tarball; then							\
	  if ! test -e $@ ; then 						\
	  	echo >&2 "your DRBD source tree is broken. unpack again.";	\
		exit 1;								\
	  fi;									\
	  grep return $@ ;							\
	else									\
	  echo -ne "\treturn \"SVN Revision: "; svnversion -n .; echo \";	\
	fi ;									\
	echo -e "\t\t\" build by $$USER@$$HOSTNAME, `date "+%F %T"`\";\n}";	\
       	mv $@{.new,}

# update of .filelist is forced:
.PHONY: .filelist
.filelist:
	@ svn info >/dev/null || { echo "you need a svn checkout to do this." ; false ; }
	@find $$(svn st -v | sed '/^?/d;s/^.\{8\} \+[0-9]\+ \+[0-9]\+ [a-z]\+ *//;/^debian/d' ) \
	\! -type d -maxdepth 0 |\
	sed 's:^:drbd-$(DIST_VERSION)/:' > .filelist
	@[ -s .filelist ] # assert there is something in .filelist now
	@find documentation -name "[^.]*.[58]" -o -name "*.html" | \
	sed "s/^/drbd-$(DIST_VERSION)\//" >> .filelist           ;\
	echo drbd-$(DIST_VERSION)/drbd_config.h >> .filelist     ;\
	echo drbd-$(DIST_VERSION)/drbd/drbd_buildtag.c >> .filelist ;\
	echo drbd-$(DIST_VERSION)/.filelist >> .filelist         ;\
	echo "./.filelist updated."

# tgz will no longer automatically update .filelist,
# so the tgz and therefore rpm target will work within
# an extracted tarball, too.
# to generate a distribution tarball, use make tarball,
# which will regenerate .filelist 
tgz:
	test -e .filelist
	ln -sf drbd/linux/drbd_config.h drbd_config.h
	rm -f drbd-$(DIST_VERSION)
	ln -s . drbd-$(DIST_VERSION)
	set -e ; for f in $$(<.filelist) ; do [ -e $$f ] ; done
	tar --owner=0 --group=0 -czf drbd-$(DIST_VERSION).tar.gz -T .filelist
	rm drbd-$(DIST_VERSION)

ifeq ($(FORCE),)
tgz: check_changelogs_up2date doc
endif

check_all_committed:
	@modified=`svn st -q`; 		\
	if test -n "$$modified" ; then	\
		echo "$$modified";	\
	       	false;			\
	fi

tarball: check_all_committed distclean doc .filelist tgz
all tools doc .filelist: drbd/drbd_buildtag.c

KDIR := $(shell echo /lib/modules/`uname -r`/build)
KVER := $(shell \
	echo -e "\#include <linux/version.h>\ndrbd_kernel_release UTS_RELEASE" | \
        gcc -nostdinc -E -P -I$(KDIR)/include - 2>&1 | \
        sed -ne 's/^drbd_kernel_release "\(.*\)".*/\1/p')

kernel-patch: drbd/drbd_buildtag.c
	set -o errexit; \
	kbase=$$(basename $(KDIR)); \
	d=patch-$$kbase-drbd-$(DIST_VERSION); \
	test -e $$d && cp -fav --backup=numbered $$d $$d; \
	bash scripts/patch-kernel $(KDIR) . > $$d

# maybe even dist/RPMS/$(ARCH) ?
rpm: tgz
	mkdir -p dist/BUILD \
	         dist/RPMS  \
	         dist/SPECS \
	         dist/SOURCES \
	         dist/TMP \
	         dist/install \
	         dist/SRPMS
	[ -h dist/SOURCES/drbd-$(DIST_VERSION).tar.gz ] || \
	  $(LN_S) $(PWD)/drbd-$(DIST_VERSION).tar.gz \
	          $(PWD)/dist/SOURCES/drbd-$(DIST_VERSION).tar.gz
	if test drbd.spec.in -nt dist/SPECS/drbd.spec ; then \
	   sed -e "s/^\(Version:\).*/\1 $(DIST_VERSION)/;" \
	       -e "s/^\(Packager:\).*/\1 $(USER)@$(HOSTNAME)/;" < drbd.spec.in \
	   > dist/SPECS/drbd.spec ; \
	fi
	$(RPMBUILD) -ba \
	    --define "_topdir $(PWD)/dist" \
	    --define "buildroot $(PWD)/dist/install" \
	    --define "kernelversion $(KVER)" \
	    --define "kdir $(KDIR)" \
	    $(RPMOPT) \
	    $(PWD)/dist/SPECS/drbd.spec
	@echo "You have now:" ; ls -l dist/*RPMS/*/*.rpm


# the INSTALL file is writen in lge-markup, which is basically
# wiki style plus some "conventions" :)
# why don't I write in or convert to HTML directly?
# editing INSTALL feels more natural this way ...

INSTALL.html: INSTALL.pod
	-pod2html --title "Howto Build and Install DRBD" \
		< INSTALL.pod > INSTALL.html ; rm -f pod2htm*
#	-w3m -T text/html -dump < INSTALL.html > INSTALL.txt

INSTALL.pod: INSTALL
	-@perl -pe 'BEGIN { print "=pod\n\n"; };                  \
	 	s/^= +(.*?) +=$$/=head1 $$1/;                     \
	 	s/^== +(.*?) +==$$/=head2 $$1/;                   \
		s/^(Last modi)/ $$1/ and next;                    \
	 	if(s/^ +([^#]*)$$/$$1/ or /^\S/) {                \
			s/(Note:)/B<$$1>/g;                       \
			s/"([^"]+)"/C<$$1>/g;                     \
	 		s,((^|[. ])/(`[^`]*`|\S)+),C<$$1>,g;      \
	 	}' \
	 	< INSTALL > INSTALL.pod

=== debian/changelog ===
drbd (0.7.7-1) unstable; urgency=low

  * (Cyril Bouthors)
     - New upstream release

 -- Cyril Bouthors <cyril@bouthors.org>  Wed, 15 Dec 2004 17:15:35 +0300

drbd (0.7.6-2) unstable; urgency=low

  * (Cyril Bouthors)
     - drbd0.7-module-source: Moved debhelper from Recommends to Depends

 -- Cyril Bouthors <cyril@bouthors.org>  Thu,  9 Dec 2004 20:37:41 +0300

drbd (0.7.6-1) unstable; urgency=low

  * (Cyril Bouthors)
     - New upstream release
     - debian/control.modules.in: updated description
     - debian/TODO: removed

 -- Cyril Bouthors <cyril@bouthors.org>  Tue, 30 Nov 2004 19:43:27 +0300

drbd (0.7.5-2) unstable; urgency=low

  * (Philipp Hug)
    - debian/control: Added Conflict with drbd-util and drbd-module-source
    - debian/control.in.modules: Fixed description for kernel module
    - debian/control.in.modules: Added Conflict line in kernel module package
    - debian/control.in.modules: Change depends to drbd0.7-util
    - debian/rules: don't use top-level makefile, to prevent re-creation of
      drbd_buildtag.c
    - call depmod in postinst of kernel module
    - debian/rules: remove obsolete upstream ./debian/ files in clean target
    - added module-assistant override file
    - this version is ready for sarge (Closes: #277669)

 -- Philipp Hug <debian@hug.cx>  Tue, 19 Oct 2004 20:50:49 +0200

drbd (0.7.5-1) unstable; urgency=low

  * (Cyril Bouthors)
    - New upstream release (closes: #276640).
    - debian/drbd0.7.dirs: removed usr/bin (closes: #276643).
    - debian/control: changed Section from misc to admin.
    - scripts/drbd: prevent the "stop" target from failing if drbd is not running
    - debian/rules: call upstream Makefile targets instead of doing hardcoded stuff, clean.
    - debian/drbd0.7.docs: added upgrade_0.6.x_to_0.7.0.txt and upgrade_0.7.0_to_0.7.1.txt.
    - The package drbd as been renamed to drbd0.7-utils and drbd-source as
      been renamed to drbd0.7-module-source.  We'll introduce drbd0.6-*
      and drbd*-module soon.
    - Added myself as Uploader.

  * (Philipp Hug)
    - Conflict with drbd and drbd-source
    - Fixed description for kernel modules
    - Added Conflict line in kernel-module package
    - Added bison, flex to Build-Depends
    - Call 'make clean' in drbd directory
    - Upgraded to debian-policy 3.6.1
    - Rewritten debian/rules using module-assistant
    - Change binary package name to drbd0.7
    - Added myself as Uploader

 -- Cyril Bouthors <cyril@bouthors.org>  Sat, 16 Oct 2004 23:43:27 +0200

drbd (0.7.4-1) unstable; urgency=low

  * Fixed a critical bug with Linux-2.4.x and HIGHMEM!
  * Fixed a bug that only showed up with the HIGHMEM problem on
    Linux-2.4.x -> It caused the resync process to starve.
  * The drbd.spec file now creates /dev/drbd in the post-install stage.
  * Fixed support for more than 2TB storage. Now DRBD supports up to
    3.99TB storage. It will also tell you, that it is not supported if
    you try to set up a bigger device.
  * Debian's build rules file now knows about the adjust_drbd_config_h.sh
    file.
  * DRBD_DISABLE_SENDPAGE available in drbd_config.h

 -- Philipp Reisner <phil@linbit.com>  Thu, 9 Sep 2004 19:50:00 +0200

drbd (0.7.3-2) unstable; urgency=low

  * Fixed debian/rules: Include adjust_drbd_config_h.sh in drbd-source

 -- Philipp Hug <debian@hug.cx>  Tue, 31 Aug 2004 15:37:38 +0000

drbd (0.7.3-1) unstable; urgency=low

  * Fixed minor bugs in the handling of the generation counters.
  * prevent possible in-kernel buffer overflow in drbd_proc.c
  * Fixed debian's postinst script to create /dev/drbd? instead of /dev/nb?
  * drbd status:
    be nice to heartbeat, include "OK" in output.
  * added FullSync meta data flag to read/write gc.pl
  * make the RHEL3 happy (page_count no longer in mm.h, but in mm_inline.h)
  * [Patch by Pavel Semerad]. Also use the drbd_devfs_name on Linux-2.4.x
  * fix missing dependencies on drbd_config.h

 -- Philipp Reisner <phil@linbit.com>  Fri, 27 Aug 2004 15:02:00 +0200

drbd (0.7.2-1) unstable; urgency=low

  * Proper handling of backing storage devices that occasionally fail
    READA (=read ahead) requests. (E.g. LVM and MD)
  * DRBD now fails READA requests itself, if a resynchronisation is running
    and it would need to fetch the block from its peer.
  * "drbdadm adjust" had a race, which caused random errors. ( Missing
    waitpid() ). Fixed now.
  * Proper subtract SyncPause times from the syncer performance numbers.
  * Fix to the syncer progress bar in /proc/drbd.
  * Fix to debian build rules.

 -- Philipp Reisner <phil@linbit.com>  Fri, 6 Aug 2004 14:44:31 +0200

drbd (0.7.1-1) unstable; urgency=low

  * Upgrade instructions for 0.6.x -> 0.7.0 and 0.7.0 -> 0.7.1
  * Workaround for XFS' IO requests with page count of zero.
  * Handle the human and the timeout count correctly in the new init script.
  * The implementation of the incon-degr-cmd was missing, added.
  * Fix for integer overflow in /proc/drbd syncer progress display
  * Longer timeouts in drbdadm for drbdsetup commands witch operate on
    meta data.
  * New major number 147 (officially registered at lanana.org).
  * Added a missing w_resume_next_wg() in case we stop syncing because
    of connection loss.
  * Fixed a Linux-2.2-ismus in recieve_data_tail(). Should considerably
    speed up protocols A and B.
  * Some work on vendor kernel compatibility

 -- Philipp Reisner <phil@linbit.com>  Fri, 30 Jul 2004 13:50:33 +0200

drbd (0.7.0-1) unstable; urgency=low

  * s/WriteHint/UnplugRemote/g
  * new module parameter major_nr to allow "arbitrary" major numbers
  * adjusted CTH to cope with that
  * fix copy'n'paste and conversion errors in initial bitmap handshake
  * warning "please upgrade me" if peer speaks (PRO_VERSION+1)
  * drbd_set_in_sync and drbd_set_out_of_sync are now macros
    calling to __*, giving file and line information,
    to be able to easily track causes of "strange state"s there.


=== debian/control ===
Source: drbd
Section: admin
Priority: extra
Maintainer: David Krovich <dkrovich@csee.wvu.edu>
Uploaders: Philipp Hug <debian@hug.cx>, Cyril Bouthors <cyril@bouthors.org>
Build-Depends: debhelper (>= 4), debconf-utils, sp, docbook-utils, bison, flex
Standards-Version: 3.6.1

Package: drbd0.7-utils
Architecture: any
Section: admin
Depends: debconf
Conflicts: drbd-utils, drbd
Provides: drbd-utils
Replaces: drbd-utils, drbd
Suggests: heartbeat
Description: RAID 1 over tcp/ip for Linux utilities
 Drbd is a block device which is designed to build high availability
 clusters by providing a virtual shared device which keeps disks in nodes
 synchronised using TCP/IP. This simulates RAID 1 but avoiding the 
 use of uncommon hardware (shared SCSI buses or Fibre Channel). 
 It is currently limited to fail-over HA clusters.
 .
 This package contains the programs that will control the 
 drbd kernel module provided in drbd-source. You will need a clustering
 service (such as heartbeat) to fully implement it.
 .
 Homepage: http://www.drbd.org

Package: drbd0.7-module-source
Architecture: all
Section: admin
Depends: module-assistant, debhelper (>= 4), 
Conflicts: drbd-module-source, drbd-source
Provides: drbd-module-source
Replaces: drbd-module-source, drbd-source
Recommends:  dpkg-dev, kernel-package, debconf-utils
Description: RAID 1 over tcp/ip for Linux module source
 Drbd is a block device which is designed to build high availability
 clusters by providing a virtual shared device which keeps disks in nodes
 synchronised using TCP/IP. This simulates RAID 1 but avoiding the 
 use of uncommon hardware (shared SCSI buses or Fibre Channel). 
 It is currently limited to fail-over HA clusters.
 .
 This package contains the programs that will control the 
 drbd kernel module provided in drbd-source. You will need a clustering
 service (such as heartbeat) to fully implement it.
 .
 Homepage: http://www.drbd.org

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

PACKAGE=drbd0.7-module
MA_DIR ?= /usr/share/modass
-include $(MA_DIR)/include/generic.make
-include $(MA_DIR)/include/common-rules.make

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

# module-assistant stuff
MAJOR=$(shell echo $(KVERS) | sed -e 's/\(...\).*/\1/')
ifeq ($(MAJOR),2.6)
KO=k
endif

kdist_clean:
	dh_clean
	-$(MAKE) -C drbd clean

# prep-deb-files rewrites the debian/ files as needed. See RATIONALE for
# details
kdist_config: prep-deb-files
# ... additional kernel specific things to configure...

kdist_configure: kdist_config

binary-modules: prep-deb-files
	dh_testdir
	dh_testroot
	dh_clean -k
	$(MAKE) -C drbd KERNEL_SOURCES=$(KSRC) MODVERSIONS=detect KERNEL=linux-$(KVERS) KDIR=$(KSRC)
	install -m644 -b -D drbd/drbd.$(KO)o $(CURDIR)/debian/$(PKGNAME)/lib/modules/$(KVERS)/kernel/drivers/block/drbd.$(KO)o
	dh_installdocs
	dh_installchangelogs
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol -- -v$(VERSION)
	dh_md5sums
	dh_builddeb --destdir=$(DEB_DESTDIR)

#Architecture 
build: build-arch build-indep

build-arch: build-arch-stamp
build-arch-stamp: 
	dh_testdir
	$(MAKE) -C user
	$(MAKE) -C scripts
	$(MAKE) -C benchmark
	$(MAKE) -C documentation doc
	touch build-arch-stamp

build-indep: build-indep-stamp
build-indep-stamp: 
	touch build-indep-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-arch-stamp build-indep-stamp #CONFIGURE-STAMP#
#	remove these files from upstream tgz
	rm -f debian/drbd0.7.*
	rm -f debian/drbd0.7-source.dirs
	rm -f debian/kernel-patch-wup.kpatches debian/kernel-patch-wup.README.Debian debian/kernel-export-wup.patch
	-$(MAKE) -C user clean
	-$(MAKE) -C scripts clean
	-$(MAKE) -C benchmark clean
	-$(MAKE) -C documentation clean
	-$(MAKE) -C drbd clean
	dh_clean 

install: install-arch install-indep
install-indep:
	dh_testdir
	dh_testroot
	dh_clean -k -i 
	dh_installdirs -i
	cp -a drbd/* debian/$(PACKAGE)-source/usr/src/modules/drbd/drbd
	cp Makefile debian/$(PACKAGE)-source/usr/src/modules/drbd
	cp drbd/linux/drbd_config.h debian/$(PACKAGE)-source/usr/src/modules/drbd
	mkdir debian/$(PACKAGE)-source/usr/src/modules/drbd/scripts/
	cp -a scripts/adjust_drbd_config_h.sh debian/$(PACKAGE)-source/usr/src/modules/drbd/scripts/

#	 install debian/ files
	cd debian ; cp changelog control compat *.modules.in rules copyright $(PACKAGE)-source/usr/src/modules/drbd/debian

#	 tar the stuff
	cd debian/$(PACKAGE)-source/usr/src/ ; tar pzfvc drbd0.7.tar.gz modules ; rm -rf modules

	install -m 755 $(CURDIR)/debian/modass.drbd0.7-module-source $(CURDIR)/debian/$(PACKAGE)-source/usr/share/modass/overrides/drbd0.7-module-source
	dh_install -i

install-arch:
	dh_testdir
	dh_testroot
	dh_clean -k -s 
	dh_installdirs -s
	$(MAKE) PREFIX=$(CURDIR)/debian/drbd0.7-utils/ -C user install
	$(MAKE) PREFIX=$(CURDIR)/debian/drbd0.7-utils/ -C scripts install
	$(MAKE) PREFIX=$(CURDIR)/debian/drbd0.7-utils/ -C benchmark install
	$(MAKE) PREFIX=$(CURDIR)/debian/drbd0.7-utils/ -C documentation install

	dh_install -s
# Must not depend on anything. This is to be called by
# binary-arch/binary-indep
# in another 'make' thread.
binary-common:
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_installexamples
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate	
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress 
	dh_fixperms
#	dh_perl
#	dh_python
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb
# Build architecture independant packages using the common target.
binary-indep: build-indep install-indep
	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common

# Build architecture dependant packages using the common target.
binary-arch: build-arch install-arch
	$(MAKE) -f debian/rules DH_OPTIONS=-a binary-common

binary: binary-arch binary-indep
.PHONY: build clean binary-indep binary-arch binary install install-indep install-arch

## drbd 0.7.10

=== Makefile ===
--- 
+++ 
@@ -120,7 +120,7 @@
 .PHONY: .filelist
 .filelist:
 	@ svn info >/dev/null || { echo "you need a svn checkout to do this." ; false ; }
-	@find $$(svn st -v | sed '/^?/d;s/^.\{8\} \+[0-9]\+ \+[0-9]\+ [a-z]\+ *//;/^debian/d' ) \
+	@find $$(svn st -v | sed '/^?/d;s/^.\{8\} \+[0-9]\+ \+[0-9]\+ [a-z]\+ *//;$(if $(PRESERVE_DEBIAN),,/^debian/d)' ) \
 	\! -type d -maxdepth 0 |\
 	sed 's:^:drbd-$(DIST_VERSION)/:' > .filelist
 	@[ -s .filelist ] # assert there is something in .filelist now

=== benchmark/Makefile ===
CFLAGS=-Wall

all: dm

install:

clean: 
	rm -f dm

distclean: clean

=== documentation/Makefile ===
# Makefile in documentation directory
#
# This file is part of drbd by Philipp Reisner
#
# drbd is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# drbd is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with drbd; see the file COPYING.  If not, write to
# the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
#
#
# For Debian:
# nsgmls drbdsetup.sgml | sgmlspl /usr/lib/perl5/sgmlspl-specs/docbook2man-spec.pl
# On RedHat it is at:
# /usr/share/sgml/docbook/utils-0.6/helpers/docbook2man-spec.pl
# the RedHat only way is docbook2man
# hmmm, nowadays docbook2man works also on Debian

LANGS =

MAKEFILES_LANG := $(foreach dir,$(LANGS),$(dir)/Makefile)

MANPAGES       := drbdsetup.8 drbd.conf.5 drbd.8 drbdadm.8

#
# Docbook Magic for SuSE, Worksforme...
# Needs to be explicitly enabled with make doc DIST=SuSE-9.0
# requires these packages and their dependencies:
#  docbook-dsssl-stylesheets docbook-toys
#  docbook-utils docbook-utils opensp perl-SGMLS
#
ifeq ($(DIST),SuSE-9.0)
  # dockbook2man just does not work.
  # this does:
  DB2MAN :=\
  @_db2man() { in=$$1		;\
   echo "  [DB2MAN] $$in"	;\
   nsgmls "$$in" |\
   sgmlspl /usr/share/sgml/docbook/utils-0.6.6/helpers/docbook2man-spec.pl;\
  }; _db2man
  
  # dockbook2html produces errors and swallows tables.
  # db2html works, but in contrast do dockbook2man creates 
  # a subdirectory and some extra files ...
  # this works for me:
  DB2HTML :=\
  _db2html() { in=$$1; base=$${in%.sgml}		;\
   echo " [DB2HTML] $$in"			;\
   db2html "$$in"				;\
   ln -sf t1.html $$base/index.html		;\
   mv $$base/*.html .		                ;\
   rm -rf $$base/   		                ;\
  }; _db2html

else

 DB2MAN          := $(shell which 2>/dev/null docbook2man)
 DB2HTML         := $(shell which 2>/dev/null docbook2html)
 DB2PDF          := $(shell which 2>/dev/null docbook2pdf)
 DB2PS           := $(shell which 2>/dev/null docbook2ps)

endif


####### Implicit rules

.SUFFIXES: .sgml .5 .8 .html .pdf .ps

.sgml.5:
	$(DB2MAN) $<

.sgml.8:
	$(DB2MAN) $<

.sgml.html:
	$(DB2HTML) $<
	mv index.html $@

.sgml.pdf:
	$(DB2PDF) $< 

.sgml.ps:
	$(DB2PS) $< 
	gzip -c $@ > $@.gz

#######

all:
	@echo "To (re)make the documentation: make doc"

clean:
	@echo "To clean the documentation: make doc-clean"

ifneq ($(DB2MAN)$(DB2HTML)$(DB2PDF)$(DB2PS),)
doc:	prepare man

doc-clean: distclean

else

doc:
	@echo "could not find docbook tools, sorry."

doc-clean:
	@echo "could not find docbook tools, leaving documentation in place."

endif

distclean:
	rm -f *.[58] manpage.links manpage.refs *~ manpage.log
	rm -f *.ps.gz *.pdf *.ps *.html pod2htm*
	@ set -e; for i in $(LANGS); do ln -sf ../Makefile.lang $$i/Makefile ; $(MAKE) -C $$i clean ; rm $$i/Makefile ; done

$(MAKEFILES_LANG): Makefile.lang
	ln -sf ../Makefile.lang $@

prepare: $(MAKEFILES_LANG)


#	@ set -e; for i in $(LANGS); do ln -sf ../Makefile.lang $$i/Makefile; done

man:	$(MANPAGES)
	@ set -e; for i in $(LANGS); do $(MAKE) -C $$i man; done	

install:
	@ok=true; for f in $(MANPAGES) ; \
		do [ -e $$f ] || { echo $$f missing ; ok=false; } ; \
	done ; $$ok
	set -e; for f in $(MANPAGES) ; do \
		s=$${f##*.}; \
		install -v -D -m 644 $$f $(PREFIX)/usr/share/man/man$$s/$$f ; \
	done
	@ set -e; for i in $(LANGS); do $(MAKE) -C $$i install; done

uninstall:
	@ set -e; for f in $(MANPAGES) ; do \
		s=$${f##*.}; \
		rm -v $(PREFIX)/usr/share/man/man$$s/$$f ; \
	done
	@ set -e; for i in $(LANGS); do $(MAKE) -C $$i uninstall; done

html:	prepare $(shell ls *.sgml | sed s/sgml/html/g)	
	@ set -e; for i in $(LANGS); do $(MAKE) -C $$i html; done	
pdf:	prepare $(shell ls *.sgml | sed s/sgml/pdf/g)
	@ set -e; for i in $(LANGS); do $(MAKE) -C $$i pdf; done	
ps:	prepare $(shell ls *.sgml | sed s/sgml/ps/g)
	@ set -e; for i in $(LANGS); do $(MAKE) -C $$i ps; done

=== drbd/Makefile ===
# makefile for drbd for linux 2.4 // 2.6
#
# By Lars Ellenberg.
#
# drbd is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# drbd is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with drbd; see the file COPYING.  If not, write to
# the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
#

# usage: make [ KDIR=/path/to/kernel/source ]
#
# this file is read twice:
# the first invocation calls out to the toplevel Makefile in the
# kernel source tree, which then in turn will call this file again
# as subdir Makefile, with all appropriate vars and macros set.
#
# note: if you get strange make errors when ARCH=um, you
# probably need to "make mrproper" in the KDIR first... 

ifneq ($(KERNELRELEASE),)
  ifneq ($(VERSION),2)
    $(error "won't compile with this kernel version")
  endif
  ifeq ($(findstring $(PATCHLEVEL),46),$(PATCHLEVEL))
    include $(DRBDSRC)/Makefile-2.$(PATCHLEVEL)
  else
    $(error "won't compile with this kernel version")
  endif

  override CFLAGS += -I$(DRBDSRC)
  # remember KERNELRELEASE for install target
  # .kernelversion can be included in Makefile as well as
  # sourced from shell
  $(shell echo -e "VERSION=$(VERSION)\n"             \
                  "PATCHLEVEL=$(PATCHLEVEL)\n"       \
                  "SUBLEVEL=$(SUBLEVEL)\n"           \
                  "EXTRAVERSION=$(EXTRAVERSION)\n"   \
                  "KERNELRELEASE=$(KERNELRELEASE)" \
          > $(DRBDSRC)/.kernelrelease.new \
   )
else
  # called from command line in current directory
  DRBDSRC := $(shell pwd)
  CONFIG_BLK_DEV_DRBD := m
  export DRBDSRC CONFIG_BLK_DEV_DRBD

  KDIR_Makefile_PATCHLEVEL = $(shell grep "^PATCHLEVEL = " $(KDIR)/Makefile | cut -d " " -f 3)

  # to be overridden on command line:
  PREFIX := /
  ifeq ($(wildcard ../build-for-uml),../build-for-uml)
    #### for Philipp's convenience :) 
    ARCH_UM := "ARCH=um"
    KDIR := /usr/src/linux-um
  else
    KDIR := /lib/modules/$(shell uname -r)/build
  endif

  # shell ls, because some of them may be missing
  # inside a patched kernel source tree
  SRC_FILES := $(shell ls 2>/dev/null\
	linux/drbd_config.h linux/drbd.h drbd_actlog.c drbd_bitmap.c drbd_fs.c \
	drbd_main.c drbd_proc.c drbd_receiver.c drbd_req.c drbd_worker.c \
	lru_cache.c drbd_compat_types.h drbd_compat_wrappers.h drbd_int.h \
	lru_cache.h hlist.h mempool-2.4.c mempool.h)

  .PHONY: drbd.o default all greeting clean kbuild install dep

  drbd.o: greeting kbuild
  default: drbd.o
  all:     drbd.o

  greeting:
	@echo "" ;\
	echo "    Calling toplevel makefile of kernel source tree, which I believe is in" ;\
	echo "    KDIR=$(KDIR)" ; \
	echo ""

  drbd_buildtag.c: $(SRC_FILES)
	@if grep ^drbd/drbd_buildtag.c: ../Makefile &>/dev/null; then \
	  $(MAKE) -C .. drbd/drbd_buildtag.c ;\
	 else \
	  echo "drbd_buildtag.c outdated." ;\
	  echo "you probably need to do a 'make' in DRBDs toplevel directory.";\
	  false ;\
	 fi

  kbuild: drbd_buildtag.c
	@rm -f .kernelrelease*
	-test -f ../scripts/adjust_drbd_config_h.sh && \
	 KDIR=$(KDIR) $(SHELL) ../scripts/adjust_drbd_config_h.sh
  ifeq ($(KDIR_Makefile_PATCHLEVEL),4)
	$(MAKE) -C $(KDIR) SUBDIRS=$(DRBDSRC) $(ARCH_UM) modules
  else
    # since 2.6.6 (suse: 2.6.5-dunno), this should be:
    # $(MAKE) -C $(KDIR) M=$(DRBDSRC) $(ARCH_UM) modules
	$(MAKE) -C $(KDIR) SUBDIRS=$(DRBDSRC) $(ARCH_UM) modules
  endif
	@mv .kernelrelease.new .kernelrelease
	@echo -n "Memorizing module configuration ... "
	@{ echo -e "#\n# drbd.o was compiled with"          ; \
	  echo "#  `gcc -v 2>&1 | tail -1`"                 ; \
	  echo "# against this kernelrelease:"              ; \
	  sed 's/^/#  /' .kernelrelease                     ; \
          echo    "# kernel .config from"                   ; \
	  echo -n "#  $(KDIR)/.config"                      ; \
          test -L "$(KDIR)" && echo "	alias"   &&           \
	  echo "#  $$(readlink $(KDIR))/.config" || echo "" ; \
	  echo -e "# follows\n#\n"                             ; \
	  cat $(KDIR)/.config ; } | gzip > .kernel.config.gz
	@echo "done."

  ifneq ($(KDIR_Makefile_PATCHLEVEL),6)
    # obsolete in 2.6 ...
    dep:
	@echo "trying to make dep ..."
	@$(MAKE) -s -C $(KDIR) SUBDIRS=$(DRBDSRC) $(ARCH_UM) dep || \
         echo "I'll ignore this error, but this can cause inconsistencies!"

    kbuild: dep
  endif

  clean:
	rm -f *.[oas] *.ko .*.cmd .*.d .*.tmp *.mod.c .*.flags .depend .kernel*

  distclean: clean

  ifneq ($(wildcard .kernelrelease),)
    # for VERSION, PATCHLEVEL, SUBLEVEL, EXTRAVERSION, KERNELRELEASE
    include .kernelrelease
    MODOBJ-4 := drbd.o
    MODOBJ-6 := drbd.ko
    MODOBJ   := $(MODOBJ-$(PATCHLEVEL))
    MODSUBDIR := $(strip \
      $(if $(wildcard /lib/modules/$(KERNELRELEASE)/kernel),\
           kernel/drivers/block,\
           block))
    LINUX := $(wildcard /lib/modules/$(KERNELRELEASE)/build)

    install:
	@if ! [ -e $(MODOBJ) ] ; then \
	  echo "No $(MODOBJ): nothing to install??"; false ; \
	fi
# install -d $(PREFIX)/var/lib/drbd
	install -d $(PREFIX)/lib/modules/$(KERNELRELEASE)/$(MODSUBDIR)
	install -m 644 $(MODOBJ) $(PREFIX)/lib/modules/$(KERNELRELEASE)/$(MODSUBDIR)
    ifeq ($(shell uname -r),$(KERNELRELEASE))
	/sbin/depmod -a || /sbin/depmod -e $(MODOBJ) 2>&1 >/dev/null || true
    else
	[ -e $(LINUX)/System.map ] && \
	   /sbin/depmod -F $(LINUX)/System.map -e ./$(MODOBJ) 2>&1 >/dev/null || true
    endif
  else
    install:
	@echo "No .kernelrelease found. Do you need to 'make' the module first?"
	@false
  endif

  depmod:
	[ -e $(KDIR)/System.map ] && [ -e ./$(MODOBJ) ] && \
	   /sbin/depmod -F $(KDIR)/System.map -n -e ./$(MODOBJ) # 2>&1 >/dev/null
endif

## drbd 0.7.11

=== Makefile ===
--- 
+++ 
@@ -32,11 +32,16 @@
 # or to forcefully include the svn-last-changed-date in the tgz name:
 #   make distclean doc tgz FORCE=1
 #
-REL_VERSION := $(REL_VERSION)-$(shell svn info| \
-		  sed -ne 's/^Last Changed Date: \([0-9]*\)-\([0-9]*\)-\([0-9]*\).*/\1\2\3/p')
+REL_VERSION := $(REL_VERSION)-$(shell LANG= svn info| \
+	sed -n -e 's/^Last Changed Date: \([0-9]*\)-\([0-9]*\)-\([0-9]*\).*/\1\2\3/p' \
+	)-$(shell svnversion .)
 endif
 
 DIST_VERSION := $(subst -,_,$(REL_VERSION))
+FDIST_VERSION := $(shell sed -ne 's,^drbd-\([^/]*\)/.*,\1,p;q' < .filelist)
+ifeq ($(FDIST_VERSION),)
+FDIST_VERSION := $(DIST_VERSION)
+endif
 
 LN_S = ln -s
 RPMBUILD=rpmbuild
@@ -122,7 +127,7 @@
 	@ svn info >/dev/null || { echo "you need a svn checkout to do this." ; false ; }
 	@find $$(svn st -v | sed '/^?/d;s/^.\{8\} \+[0-9]\+ \+[0-9]\+ [a-z]\+ *//;$(if $(PRESERVE_DEBIAN),,/^debian/d)' ) \
 	\! -type d -maxdepth 0 |\
-	sed 's:^:drbd-$(DIST_VERSION)/:' > .filelist
+	sed 's#^#drbd-$(DIST_VERSION)/#' > .filelist
 	@[ -s .filelist ] # assert there is something in .filelist now
 	@find documentation -name "[^.]*.[58]" -o -name "*.html" | \
 	sed "s/^/drbd-$(DIST_VERSION)\//" >> .filelist           ;\
@@ -139,24 +144,31 @@
 tgz:
 	test -e .filelist
 	ln -sf drbd/linux/drbd_config.h drbd_config.h
-	rm -f drbd-$(DIST_VERSION)
-	ln -s . drbd-$(DIST_VERSION)
+	rm -f drbd-$(FDIST_VERSION)
+	ln -s . drbd-$(FDIST_VERSION)
 	set -e ; for f in $$(<.filelist) ; do [ -e $$f ] ; done
-	tar --owner=0 --group=0 -czf drbd-$(DIST_VERSION).tar.gz -T .filelist
-	rm drbd-$(DIST_VERSION)
+	grep debian .filelist >/dev/null 2>&1 && _DEB=-debian || _DEB="" ; \
+	tar --owner=0 --group=0 -czf drbd-$(FDIST_VERSION)$$_DEB.tar.gz -T .filelist
+	rm drbd-$(FDIST_VERSION)
 
 ifeq ($(FORCE),)
 tgz: check_changelogs_up2date doc
 endif
 
 check_all_committed:
-	@modified=`svn st -q`; 		\
+	@$(if $(FORCE),-,)modified=`svn st -q`; 		\
 	if test -n "$$modified" ; then	\
 		echo "$$modified";	\
 	       	false;			\
 	fi
 
-tarball: check_all_committed distclean doc .filelist tgz
+prepare_release:
+	$(MAKE) tarball
+	$(MAKE) tarball PRESERVE_DEBIAN=1
+
+tarball: check_all_committed distclean doc .filelist
+	$(MAKE) tgz
+
 all tools doc .filelist: drbd/drbd_buildtag.c
 
 KDIR := $(shell echo /lib/modules/`uname -r`/build)
@@ -181,11 +193,11 @@
 	         dist/TMP \
 	         dist/install \
 	         dist/SRPMS
-	[ -h dist/SOURCES/drbd-$(DIST_VERSION).tar.gz ] || \
-	  $(LN_S) $(PWD)/drbd-$(DIST_VERSION).tar.gz \
-	          $(PWD)/dist/SOURCES/drbd-$(DIST_VERSION).tar.gz
+	[ -h dist/SOURCES/drbd-$(FDIST_VERSION).tar.gz ] || \
+	  $(LN_S) $(PWD)/drbd-$(FDIST_VERSION).tar.gz \
+	          $(PWD)/dist/SOURCES/drbd-$(FDIST_VERSION).tar.gz
 	if test drbd.spec.in -nt dist/SPECS/drbd.spec ; then \
-	   sed -e "s/^\(Version:\).*/\1 $(DIST_VERSION)/;" \
+	   sed -e "s/^\(Version:\).*/\1 $(FDIST_VERSION)/;" \
 	       -e "s/^\(Packager:\).*/\1 $(USER)@$(HOSTNAME)/;" < drbd.spec.in \
 	   > dist/SPECS/drbd.spec ; \
 	fi
